#!/usr/bin/env python3
""" Data Structures and Algorithms for CL 3, Assignment 4
    See <https://https://dsacl3-2021.github.io/a4/> for detailed
    instructions.

    <Please insert your name and the honor code here.>
"""

import numpy as np

def read_conllu(filename):
    """Read a CoNLL-U file, and return adjacency matrices.

    Parameters
    ----------
    filename    The name of the CoNLL-U file

    Returns a sequence (list) of Boolean numpy matrices (arrays of two
    dimensions) corresponding to the unlabeled adjacency graph
    representation of each sentence in the file.
    """
    # Exercise 4.1
    pass


def is_connected(graph):
    """Return True if all nodes of the graph are reachable from node 0.

    Parameters
    ----------
    graph    An adjacency matrix where node '0' is the special root
             node.

    Returns  True if all nodes are reachable from 0, False otherwise.
    """
    # Exercise 4.2
    pass

def find_cycle(graph):
    """Find a cycle and return the nodes participating in it.

    Parameters
    ----------
    graph    An adjacency matrix where node '0' is the special root
             node.

    Returns  A list of nodes consisting of the first cycle found, or
             an empty list if there are no cycles.
    """
    # Exercise 4.3
    pass

def break_cycles(graph):
    """Break the cycles in the graph.

    Break all cycles by attaching one of the nodes in the cycle to the
    artificial root node.

    Parameters
    ----------
    graph    An adjacency matrix where node '0' is the special root
             node.

    Returns  None
    """
    # Exercise 4.4
    pass

if __name__ == "__main__":
    ### You can use this area for quick testing (not graded/required).
    pass

